/*
 File: o2_lcl_opt.h
 Date and Time: Fri Jan 30 18:55:16 2015 
*/
#ifndef __o2_lcl_opt_h__
#define __o2_lcl_opt_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"
extern yacco2::Thread_entry ITH_o2_lcl_opt;

extern yacco2::State S1_Co2_lcl_opt;
namespace NS_o2_lcl_opt {
yacco2::THR _YACCO2_CALL_TYPE
TH_o2_lcl_opt(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_o2_lcl_opt(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[4];
};
class Co2_lcl_opt: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Ro2_lcl_opt_ = 569//start_of_rule_list + 0
    ,rhs1_Ro2_lcl_opt_ = 1
   ,R_Rminus_ = 570//start_of_rule_list + 2
    ,rhs1_Rminus_ = 2
   ,R_Rspec_parm_ = 571//start_of_rule_list + 4
    ,rhs1_Rspec_parm_ = 3
    ,rhs2_Rspec_parm_ = 4
    ,rhs3_Rspec_parm_ = 5
    ,rhs4_Rspec_parm_ = 6
    ,rhs5_Rspec_parm_ = 7
    ,rhs6_Rspec_parm_ = 8
   ,R_Rmust_lint_ = 572//start_of_rule_list + 6
    ,rhs1_Rmust_lint_ = 9
    ,rhs2_Rmust_lint_ = 10
    ,rhs3_Rmust_lint_ = 11
  };
  //no of la sets = 3
  //no of states = 19
  Co2_lcl_opt();
  ~Co2_lcl_opt();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[12];
 };
struct Ro2_lcl_opt;
struct Rminus;
struct Rspec_parm;
struct Rmust_lint;
struct Ro2_lcl_opt:public yacco2::CAbs_lr1_sym {
  Ro2_lcl_opt(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rminus:public yacco2::CAbs_lr1_sym {
  Rminus(yacco2::Parser* P);
  public:
};

struct Rspec_parm:public yacco2::CAbs_lr1_sym {
  Rspec_parm(yacco2::Parser* P);

    public:
    CAbs_lr1_sym* rtn_parm_;
  
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
};

struct Rmust_lint:public yacco2::CAbs_lr1_sym {
  Rmust_lint(yacco2::Parser* P);
  public:
  void sr3();
};

} // end of namespace

#endif
